#!/usr/bin/env ruby

require "xmlrpc/client"
require "device/lamp"

class Door1Interface
  def initialize
    @server = XMLRPC::Client.new("fe80::290:ccff:fe0f:b6c0%tlp0", "/RPC2", 62001)
  end
  attr_reader :server ;

  def getStatus
    result = @server.call("door1.getStatus",1) 
  end

  def openDoor
    # switch off
    @server.call("door1.open",1) 
  end

  def closeDoor
    # switch off
    @server.call("door1.close",0) 
  end

end

require 'div/div'
require 'div/tofusession'

class Door1Div < Div::Div 
  set_erb('erb/door1.erb')
  def initialize(session)
    super(session)
    @intf   = Door1Interface.new
    result = @intf.getStatus
    @status = result['isOpened']
  end

  def do_open(context, params)
    @intf.openDoor
    result = @intf.getStatus
    @status = result['isOpened']
  end

  def do_close(context, params)
    @intf.closeDoor
    result = @intf.getStatus
    @status = result['isOpened']
  end
end

