#!/usr/bin/env ruby

require "xmlrpc/client"
require "device/lamp"

class Lamp1Interface
  def initialize
    @server = XMLRPC::Client.new("fe80::290:ccff:fe0f:b6c0%tlp0", "/RPC2", 62000)
    result = @server.call("lamp1.getStatus",1) 
  end
  attr_reader :server

  def getStatus
    result = @server.call("lamp1.getStatus",1) 
  end

  def onSwitch
    # switch off
    @server.call("lamp1.setSw",1) 
  end

  def offSwitch
    # switch off
    @server.call("lamp1.setSw",0) 
  end

end

require 'div/div'
require 'div/tofusession'

class Lamp1Div < Div::Div 
  set_erb('erb/lamp1.erb')
  def initialize(session)
    super(session)
    @intf   = Lamp1Interface.new
    result = @intf.getStatus
    @status = result['switch']
  end

  def do_on(context, params)
    @intf.onSwitch
    result = @intf.getStatus
    @status = result['switch']
  end

  def do_off(context, params)
    @intf.offSwitch
    result = @intf.getStatus
    @status = result['switch']
  end
end

