require 'tofu/tofulet'
require 'drb/drb'
require 'webrick'
include WEBrick

def main
  DRb.start_service

  logger = WEBrick::Log::new($stderr, WEBrick::Log::DEBUG)
  s = WEBrick::HTTPServer.new(:Port => 63000,
			      :AddressFamily => Socket::AF_INET,
			      :BindAddress => ENV['HOSTNAME'],
			      :Logger => logger )
  s.mount("/image",HTTPServlet::FileHandler,"./image")

  #PLUG-IN:home contrller
  bartender = setup_homectrl()
  s.mount("/home",WEBrick::Tofulet,bartender)

  #PLUG-IN:entrance contrller
  bartender = setup_entrctrl()
  s.mount("/entr",WEBrick::Tofulet,bartender)

  #PLUG-IN:living contrller
  bartender = setup_livingctrl()
  s.mount("/living",WEBrick::Tofulet,bartender)

  trap("INT") {s.shutdown }
  s.start
end

# home contrl
require 'home_server'
def setup_homectrl()
  Tofu::Bartender.new(HomeTofuSession)
end

# entrance contrl
require 'entrance_server'
def setup_entrctrl()
  Tofu::Bartender.new(EntrTofuSession)
end

# living contrl
require 'living_server'
def setup_livingctrl()
  Tofu::Bartender.new(LivingTofuSession)
end

main

